program neckmain;

uses necklace;

function gwd (var buf:string; var apos:longint):string;
var cmd:string;
    len : longint;
begin
  len := length (buf);
  cmd := '';
  while (apos <= len) and (buf[apos] <> ' ') do
    begin
      cmd := cmd + buf[apos];
      inc (apos);
    end;

  while (apos <= len) and (buf[apos] = ' ') do
    inc (apos);
  gwd := cmd;
end;

procedure interactive;
var buf, cmd, tmp : string;
    id, param, last, apos : longint;
    xxx : word;
    op : char;
    left : boolean;
begin
  init ();
  writeln ('Initiated');
  last := 0;

  while true do
    begin
      readln (buf);
      apos := 1;
      cmd := gwd (buf, apos);

      if cmd = 'create' then
        begin
	  tmp := gwd (buf, apos);
	  val (tmp, id, xxx);

	  tmp := gwd (buf, apos);
	  op := tmp[1];

	  tmp := gwd (buf, apos);
	  left := tmp = 'true';

	  tmp := gwd (buf, apos);
	  val (tmp, param, xxx);

	  if (op <> 'A') and (op <> 'R') then
	    writeln ('''', op, ''' is an invalid operation for create.')
	  else if id > last then
	    writeln ('Necklace ', id, ' was not created yet.')
	  else
	    begin
	      create (id, op, left, param);
	      inc (last);
	      writeln ('Done');
	    end;
	end
      else if cmd = 'pearl' then
        begin
	  tmp := gwd (buf, apos);
	  val (tmp, id,xxx);

	  tmp := gwd (buf, apos);
	  left := tmp = 'true';

	  if id > last then
	    writeln ('Necklace ', id, ' was not created yet.')
	  else
	    writeln ('Returns ', pearl (id, left));
	end
      else if cmd = 'quit' then
        exit
      else
	writeln ('Invalid command.');
   end;
end;

function fixed : integer;
var x : longint;
begin
  init;
  create (0, 'A', true, 5);
  create (1, 'A', true, 3);
  x := pearl (2, false);
  if x <> 5 then
    begin
      writeln ('Expected answer to pearl (2, false) is 5, not ', x);
      fixed := 1;
      exit;
    end;
  create (2, 'R', false, 0);
  x := pearl (3, false);
  if x <> 3 then
    begin
      writeln ('Expected answer to pearl (3, false) is 3, not ', x);
      fixed := 1;
      exit;
    end;
  x := pearl (2, false);
  if x <> 5 then
    begin
      writeln ('Expected answer to pearl (2, false) is 5, not ', x);
      fixed := 1;
      exit;
    end;

  writeln ('OK');
  fixed := 0;
end;

begin
  if paramcount = 1 then
    interactive
  else
    fixed;
end.
